"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _glob = _interopRequireDefault(require("glob"));

var _compact = _interopRequireDefault(require("lodash/compact"));

var _uniq = _interopRequireDefault(require("lodash/uniq"));

var _path = require("path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var WebpackWatchPlugin = /*#__PURE__*/function () {
  function WebpackWatchPlugin() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _ref$files = _ref.files,
        files = _ref$files === void 0 ? [] : _ref$files,
        verbose = _ref.verbose,
        globOptions = _objectWithoutProperties(_ref, ["files", "verbose"]);

    _classCallCheck(this, WebpackWatchPlugin);

    this.files = files;
    this.verbose = !!verbose;
    this.globOptions = _objectSpread({
      absolute: true
    }, globOptions);
    this.filesAlreadyAdded = false;
  }

  _createClass(WebpackWatchPlugin, [{
    key: "apply",
    value: function apply(compiler) {
      var _this = this;

      // webpack 4 hooks
      (compiler.hooks ? compiler.hooks.afterCompile.tapAsync.bind(compiler.hooks.afterCompile, 'WebpackWatchPlugin') : compiler.plugin.bind(compiler, 'after-compile'))(function (compilation, callback) {
        var filesFound = [];
        var filesFoundToEclude = [];

        _this.files.map(function (pattern) {
          if (pattern.substr(0, 1) !== '!') {
            _glob["default"].sync(pattern, _this.globOptions).map(function (file) {
              return filesFound.push(file);
            });
          } else {
            _glob["default"].sync(pattern.substr(1), _this.globOptions).map(function (file) {
              return filesFoundToEclude.push(file);
            });
          }
        });

        var files = (0, _uniq["default"])((0, _compact["default"])(filesFound.map(function (file) {
          if (~filesFoundToEclude.indexOf(file)) {
            return;
          }

          return file;
        }))).map(function (file) {
          return (0, _path.resolve)(file);
        });

        if (_this.verbose && !_this.filesAlreadyAdded) {
          console.log('Additional files watched : ', JSON.stringify(files, null, 2));
        }

        if (Array.isArray(compilation.fileDependencies)) {
          files.map(function (file) {
            return compilation.fileDependencies.push(file);
          });
        } else {
          files.map(function (file) {
            return compilation.fileDependencies.add(file);
          });
        }

        _this.filesAlreadyAdded = true;
        callback();
      });
    }
  }]);

  return WebpackWatchPlugin;
}();

exports["default"] = WebpackWatchPlugin;